Index: /inundation/ga/storm_surge/pyvolution/HUSK.txt
===================================================================
--- /inundation/ga/storm_surge/pyvolution/HUSK.txt	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/HUSK.txt	(revision 272)
@@ -1,4 +1,8 @@
 
+	
+	
 Perhaps control old/new style with minimum_allowed height
+In any case get rid of oldstyle.
+Then optimise protect_against.....
 	
 Test friction term!
Index: /inundation/ga/storm_surge/pyvolution/config.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/config.py	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/config.py	(revision 272)
@@ -5,6 +5,4 @@
 
 default_boundary_tag = 'exterior'
-
-newstyle = False #Flase meqans that we are equivalent to previous version pyvolution2
 
 
@@ -57,10 +55,9 @@
 
 
-
 use_extensions = True   #Try to use C-extensions
 #use_extensions = False   #Do not use C-extensions
 
 use_psyco = True  #Use psyco optimisations
-#use_psyco = False  #Do not use psyco optimisations
+use_psyco = False  #Do not use psyco optimisations
 
 
Index: /inundation/ga/storm_surge/pyvolution/domain.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/domain.py	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/domain.py	(revision 272)
@@ -72,8 +72,7 @@
 
         #Defaults
-        from config import max_smallsteps, beta, newstyle, epsilon
+        from config import max_smallsteps, beta, epsilon
         self.beta = beta
         self.epsilon = epsilon        
-        self.newstyle = newstyle
         self.default_order = 1
         self.order = self.default_order
Index: /inundation/ga/storm_surge/pyvolution/quantity.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/quantity.py	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/quantity.py	(revision 272)
@@ -226,24 +226,7 @@
 
     def update(self, timestep):
-        """Update centroid values based on values stored in
-        explicit_update and semi_implicit_update as well as given timestep
-        """
-
-        from Numeric import sum, equal, ones, Float
-        
-        N = self.centroid_values.shape[0]
-        
-        #Explicit updates
-        self.centroid_values += timestep*self.explicit_update
-            
-        #Semi implicit updates
-        denominator = ones(N, Float)-timestep*self.semi_implicit_update
-
-        if sum(equal(denominator, 0.0)) > 0.0:
-            msg = 'Zero division in semi implicit update. Call Stephen :-)'
-            raise msg
-        else:
-            #Update conserved_quantities from semi implicit updates
-            self.centroid_values /= denominator
+        #Call correct module function
+        #(either from this module or C-extension)
+        return update(self, timestep)
 
 
@@ -278,4 +261,26 @@
         extrapolate_second_order(self)
 
+
+def update(quantity, timestep):    
+    """Update centroid values based on values stored in
+    explicit_update and semi_implicit_update as well as given timestep
+    """
+    
+    from Numeric import sum, equal, ones, Float
+        
+    N = quantity.centroid_values.shape[0]
+        
+    #Explicit updates
+    quantity.centroid_values += timestep*quantity.explicit_update
+            
+    #Semi implicit updates
+    denominator = ones(N, Float)-timestep*quantity.semi_implicit_update
+
+    if sum(equal(denominator, 0.0)) > 0.0:
+        msg = 'Zero division in semi implicit update. Call Stephen :-)'
+        raise msg
+    else:
+        #Update conserved_quantities from semi implicit updates
+        quantity.centroid_values /= denominator
 
 
@@ -462,4 +467,4 @@
     	
     from quantity_ext import limit, compute_gradients,\
-    extrapolate_second_order, interpolate_from_vertices_to_edges 
-
+    extrapolate_second_order, interpolate_from_vertices_to_edges, update 
+
Index: /inundation/ga/storm_surge/pyvolution/quantity_ext.c
===================================================================
--- /inundation/ga/storm_surge/pyvolution/quantity_ext.c	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/quantity_ext.c	(revision 272)
@@ -156,8 +156,85 @@
   return 0;
 }
+
+int _update(int N, 
+	    double timestep,
+	    double* centroid_values,
+	    double* explicit_update,
+	    double* semi_implicit_update) {
+  //Update centroid values based on values stored in
+  //explicit_update and semi_implicit_update as well as given timestep
+  
+  
+  int k;
+  double denominator;
+  
+  //Explicit updates
+  for (k=0; k<N; k++) {
+    centroid_values[k] += timestep*explicit_update[k];
+  }
+            
+  //Semi implicit updates
+  for (k=0; k<N; k++) {  
+    denominator = 1.0 - timestep*semi_implicit_update[k];  
+    
+    if (denominator == 0.0) {
+      return -1;
+    } else {
+      //Update conserved_quantities from semi implicit updates
+      centroid_values[k] /= denominator;
+    }
+  }
+  return 0;
+}
 		     
   
 /////////////////////////////////////////////////
 // Gateways to Python
+PyObject *update(PyObject *self, PyObject *args) {
+  
+  PyObject *quantity;
+  PyArrayObject *centroid_values, *explicit_update, *semi_implicit_update; 
+  
+  double timestep;  
+  int N, err;
+  
+  // Convert Python arguments to C  
+  if (!PyArg_ParseTuple(args, "Od", &quantity, &timestep)) 
+    return NULL;
+
+  centroid_values = (PyArrayObject*) 
+    PyObject_GetAttrString(quantity, "centroid_values");           
+  if (!centroid_values) return NULL;                
+
+  explicit_update = (PyArrayObject*) 
+    PyObject_GetAttrString(quantity, "explicit_update");   
+  if (!explicit_update) return NULL;          
+  
+  semi_implicit_update = (PyArrayObject*) 
+    PyObject_GetAttrString(quantity, "semi_implicit_update");   
+  if (!semi_implicit_update) return NULL;            
+
+  N = centroid_values -> dimensions[0];  
+  
+  
+  err = _update(N, timestep,
+		(double*) centroid_values -> data,
+		(double*) explicit_update -> data,
+		(double*) semi_implicit_update -> data);		
+		
+		     
+  if (err != 0) {
+    PyErr_SetString(PyExc_RuntimeError, 
+		    "Zero division in semi implicit update - call Stephen :)");
+    return NULL;
+  }		     
+  
+  //Release and return		     
+  Py_DECREF(centroid_values);    
+  Py_DECREF(explicit_update); 
+  Py_DECREF(semi_implicit_update);   
+
+  return Py_BuildValue("");
+}
 
 
@@ -471,4 +548,5 @@
 static struct PyMethodDef MethodTable[] = {
   {"limit", limit, METH_VARARGS, "Print out"},    
+  {"update", update, METH_VARARGS, "Print out"},      
   {"compute_gradients", compute_gradients, METH_VARARGS, "Print out"},      
   {"extrapolate_second_order", extrapolate_second_order, 
Index: /inundation/ga/storm_surge/pyvolution/run_profile.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/run_profile.py	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/run_profile.py	(revision 272)
@@ -30,5 +30,4 @@
 domain.default_order = 2
 #domain.visualise = True
-domain.newstyle = False  #For comparison
 
 
Index: /inundation/ga/storm_surge/pyvolution/shallow_water.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/shallow_water.py	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/shallow_water.py	(revision 272)
@@ -57,6 +57,5 @@
         self.z = self.quantities['elevation']        	
         self.eta = self.quantities['friction']        		
-	
-    
+
     def check_integrity(self):
         Generic_domain.check_integrity(self)
@@ -420,20 +419,11 @@
     #Update
     for k in range(domain.number_of_elements):
-        if domain.newstyle:
-            if hc[k] < domain.minimum_allowed_height:        
-                if hc[k] < 0.0:
-                    #Control level and height
-                    wc[k] = zc[k] #; hc[k] = 0.0
-
-                #Control momentum
-                xmomc[k] = ymomc[k] = 0.0
-        else:        
+        if hc[k] < domain.minimum_allowed_height:        
             if hc[k] < 0.0:
                 #Control level and height
-                wc[k] = zc[k]  #; hc[k] = 0.0
-
-                #Control momentum
-                xmomc[k] = ymomc[k] = 0.0
-
+                wc[k] = zc[k]
+
+            #Control momentum
+            xmomc[k] = ymomc[k] = 0.0
 
 def extrapolate_first_order(domain):
@@ -461,19 +451,4 @@
 
 
-    if not domain.newstyle:
-        #Protect against infinitesimal heights and high speeds at_centroid
-        #FIXME: To be phased out
-        
-        for k in range(domain.number_of_elements):
-            #Protect against infinitesimal heights and high velocities
-            if hc[k] < domain.minimum_allowed_height:
-                #Control level and height
-                if hc[k] < 0.0:
-                    wc[k] = zc[k]; hc[k] = 0.0#
-         
-                #Control momentum
-                xmomc[k] = ymomc[k] = 0.0
-                
-    
     #Update conserved quantities using straight first order
     for name in domain.conserved_quantities:
@@ -483,8 +458,7 @@
 
 
-    if domain.newstyle:
-        balance_deep_and_shallow(domain)                      #This will be better
-    else:    
-        old_first_order_balancing_of_deep_and_shallow(domain) #Tests will pass
+
+    balance_deep_and_shallow(domain)
+
 
     
@@ -562,5 +536,4 @@
         hmin = min( hv[k,:] )
 
-        print dz, hmin
 	
         #Create alpha in [0,1], where alpha==0 means using shallow 
@@ -968,61 +941,4 @@
             return self.W(x,y) + self.h
 
-#STUFF
-
-
-def old_first_order_balancing_of_deep_and_shallow(domain):
-    #FIXME: Will be obsolete, but keep comments from this one.
-    
-    #Computed weighted balance between constant levels and and
-    #levels parallel to the bed elevation.
-    wc = domain.quantities['level'].centroid_values
-    zc = domain.quantities['elevation'].centroid_values
-    xmomc = domain.quantities['xmomentum'].centroid_values
-    ymomc = domain.quantities['ymomentum'].centroid_values            
-    hc = wc - zc   #Water depths at centroids
-    
-    wv = domain.quantities['level'].vertex_values
-    zv = domain.quantities['elevation'].vertex_values
-    
-    for k in range(domain.number_of_elements):                
-                
-        #Compute maximal variation in bed elevation
-        z_range = max(abs(zv[k,0]-zc[k]),
-                      abs(zv[k,1]-zc[k]),
-                      abs(zv[k,2]-zc[k]))
-
-
-        #Weighted balance between stage parallel to bed elevation 
-        #(wvi = zvi + hc) and constant stage (wvi = wc = zc+hc)
-        #where i=0,1,2 denotes the vertex ids
-        #
-        #It follows that 
-        #  wvi = (1-alpha)*(zvi+hc) + alpha*(zc+hc) = 
-        #  (1-alpha)*zvi + alpha*zc + hc = 
-        #  zvi + hc + alpha*(zc-zvi)
-        #
-        #where alpha in [0,1] and defined as the ratio between hc and 
-        #the maximal difference from zc to zv0, zv1 and zv2
-        #
-        #Mathematically the following could be continued on using hc as
-        #  wvi = 
-        #  zvi + hc + alpha*(zc+hc-zvi-hc) =
-        #  zvi + hc + alpha*(hvi-hc)
-        #since hvi = zc+hc-zvi in the constant case
-
-        
-        if z_range > 0.0:
-            alpha = min(hc[k]/z_range, 1.0)
-        else: 
-            alpha = 1.0
-            
-        #Update water levels
-        for i in range(3):
-	    #FIXME: Use the original first-order one first, then switch
-            wv[k,i] = zv[k,i] + hc[k] + alpha*(zc[k]-zv[k,i])
-            #wv[k,i] = zv[k,i] + hc[k] + alpha*(hv[k,i]-hc[k]) #Requires updated hv!!
-
-        #FIXME: What about alpha weighting of momentum??
-
 
 ##############################################
Index: /inundation/ga/storm_surge/pyvolution/show_balanced_limiters.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/show_balanced_limiters.py	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/show_balanced_limiters.py	(revision 272)
@@ -38,5 +38,4 @@
 domain.visualise = True
 domain.default_order = 2
-domain.newstyle = True  #True is better
 
 
Index: /inundation/ga/storm_surge/pyvolution/test_shallow_water.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/test_shallow_water.py	(revision 271)
+++ /inundation/ga/storm_surge/pyvolution/test_shallow_water.py	(revision 272)
@@ -12,9 +12,7 @@
     def setUp(self):
         pass
-        #print "  Setting up"
         
     def tearDown(self):
         pass
-        #print "  Tearing down"
 
     def test_rotate(self):
@@ -823,6 +821,7 @@
         domain.order = 1	
         domain.distribute_to_vertices_and_edges()
-	assert allclose(L[1], [0.19999999, 20.05, 20.05])
-
+	##assert allclose(L[1], [0.19999999, 20.05, 20.05])
+	assert allclose(L[1], [0.1, 20.1, 20.1])
+        
         domain.order = 2	
         domain.distribute_to_vertices_and_edges()
@@ -865,7 +864,8 @@
 
         #print E
-        domain.order = 1	
+        domain.order = 1
         domain.distribute_to_vertices_and_edges()
-	assert allclose(L[1], [4.19999999, 16.07142857, 20.02857143])
+	##assert allclose(L[1], [4.19999999, 16.07142857, 20.02857143])
+	assert allclose(L[1], [4.1, 16.1, 20.1])        
 
         domain.order = 2	
@@ -1085,4 +1085,5 @@
         domain.visualise = False
         domain.default_order=2
+        #domain.minimum_allowed_height = 0.0 #Makes it like the 'oldstyle' balance
 
         # Boundary conditions
@@ -1106,7 +1107,12 @@
         
         assert allclose(domain.quantities['level'].vertex_values[:4,0],
-                        [0.00101913,0.05352143,0.00104852,0.05354394]) 
+                        [0.00101913,0.05352143,0.00104852,0.05354394])
+        
         assert allclose(domain.quantities['xmomentum'].vertex_values[:4,0],
-                        [0.00090581,0.03685719,0.00088303,0.03687313])
+                        [ 0.00064835, 0.03685719, 0.00085073, 0.03687313])
+
+        #assert allclose(domain.quantities['xmomentum'].vertex_values[:4,0],
+        #                [0.00090581,0.03685719,0.00088303,0.03687313])
+        
         assert allclose(domain.quantities['ymomentum'].vertex_values[:4,0],
                         [-0.00139463,0.0006156,-0.00060364,0.00061827])
@@ -1212,6 +1218,11 @@
             #print 'C19=', domain.quantities['xmomentum'].centroid_values[19]
 
-            assert allclose(domain.quantities['xmomentum'].centroid_values[17],
-                            0.00028606084)
+            #assert allclose(domain.quantities['xmomentum'].centroid_values[17],0.00028606084)
+            ##print domain.quantities['xmomentum'].centroid_values[17], V
+            ##print
+            if not V:            
+                assert allclose(domain.quantities['xmomentum'].centroid_values[17], 0.0)
+            else:  
+                assert allclose(domain.quantities['xmomentum'].centroid_values[17], 0.00028606084)            
 
             import copy
@@ -1221,8 +1232,8 @@
             domain.distribute_to_vertices_and_edges()
 
-            assert allclose(domain.quantities['xmomentum'].centroid_values, XX)
+            #assert allclose(domain.quantities['xmomentum'].centroid_values, XX)
 
             assert allclose(domain.quantities['xmomentum'].centroid_values[17],
-                            0.00028606084)
+                            0.0)
 
 
@@ -1232,4 +1243,11 @@
             assert allclose(domain.quantities['ymomentum'].vertex_values[:4,0],
                             [-0.00139463,0.0006156,-0.00060364,0.00061827])
+
+
+            assert allclose(domain.quantities['xmomentum'].vertex_values[:4,0],
+                            [0.00064835,0.03685719,0.00085073,0.03687313])
+
+
+            #NB NO longer relvant:
 
             #This was the culprit. First triangles vertex 0 had an
@@ -1237,7 +1255,8 @@
             #third triangle had 0.00850733 instead of 0.00088303
             #print domain.quantities['xmomentum'].vertex_values[:4,0]
-        
-            assert allclose(domain.quantities['xmomentum'].vertex_values[:4,0],
-                            [0.00090581,0.03685719,0.00088303,0.03687313])        
+
+            #print domain.quantities['xmomentum'].vertex_values[:4,0]
+            #assert allclose(domain.quantities['xmomentum'].vertex_values[:4,0],
+            #                [0.00090581,0.03685719,0.00088303,0.03687313])        
 
 
@@ -1277,27 +1296,6 @@
             pass# domain.write_time()
 
-        #Data from earlier version of pyvolution
-        assert allclose(domain.min_timestep, 0.0423354136479)
-        assert allclose(domain.max_timestep, 0.0479397182296)
-        assert allclose(domain.quantities['level'].centroid_values,
-                        [0.00974056, 0.02131643, 0.01373269, 0.02139684,
-                         0.01373269, 0.02139684, 0.01373269, 0.02139684,
-                         0.01373269, 0.02139684, 0.01386079, 0.0254346,
-                         -0.04562579, -0.025253, -0.04154658, -0.02512009,
-                         -0.04154658, -0.02512009, -0.04154658, -0.02512009,
-                         -0.04154658, -0.02512009, -0.04140825, -0.0210463,
-                         -0.10118135, -0.08080855, -0.09710213, -0.08067564,
-                         -0.09710213, -0.08067564, -0.09710213, -0.08067564,
-                         -0.09710213, -0.08067564, -0.0969638 , -0.07660185,
-                         -0.1567369, -0.13636411, -0.15265769, -0.1362312,
-                         -0.15265769, -0.1362312, -0.15265769, -0.1362312,
-                         -0.15265769, -0.1362312, -0.15251936, -0.13215741,
-                         -0.21229246, -0.19191967, -0.20821325, -0.19178675,
-                         -0.20821325, -0.19178675, -0.20821325, -0.19178675,
-                         -0.20821325, -0.19178675, -0.20807491, -0.18771296,
-                         -0.25875433, -0.24722502, -0.25470346, -0.24709274,
-                         -0.25470346, -0.24709274, -0.25470346, -0.24709274,
-                         -0.25470346, -0.24709274, -0.25460675, -0.24309962])
-
+        assert allclose(domain.min_timestep, 0.050010003001)
+        assert allclose(domain.max_timestep, 0.050010003001)
 
         
@@ -1335,29 +1333,32 @@
 
         #Data from earlier version of pyvolution
+        #print domain.quantities['level'].centroid_values
+        
         assert allclose(domain.quantities['level'].centroid_values,
-                        [-0.03558044, -0.01758186, -0.03457868,
-                         -0.01757463, -0.03400681, -0.01765817,
-                         -0.0334924, -0.01763917, -0.03304351,
-                         -0.01745604, -0.03259134, -0.01690249,
-                         -0.08343238, -0.06844054, -0.08114626,
-                         -0.06776272, -0.07985917, -0.0670156,
-                         -0.07857347, -0.06636824, -0.07751765,
-                         -0.06571005, -0.07694892, -0.06485356,
-                         -0.12816762, -0.11399292, -0.12388354,
-                         -0.11298543, -0.12146159, -0.11160487,
-                         -0.11890573, -0.11016723, -0.11720749,
-                         -0.10922083, -0.11748089, -0.10796284,
-                         -0.17324244, -0.15860786, -0.16784961,
-                         -0.15785693, -0.16501143, -0.1558837,
-                         -0.1618709,  -0.15384493, -0.15979744,
-                         -0.15251944, -0.15976661, -0.15094149,
-                         -0.17055387, -0.1934305, -0.17869999,
-                         -0.19402574, -0.17570318, -0.19030006,
-                         -0.17114482, -0.18720482, -0.16970896,
-                         -0.18836511, -0.17655148, -0.19499397,
-                         -0.14139494, -0.14492939, -0.14365011,
-                         -0.14969524, -0.14343543, -0.14754936,
-                         -0.13944213, -0.14337135, -0.13651514,
-                         -0.14183568, -0.13623283, -0.14529803])
+                        [-0.02998628, -0.01520652, -0.03043492,
+                        -0.0149132, -0.03004706, -0.01476251,
+                        -0.0298215, -0.01467976, -0.02988158,
+                        -0.01474662, -0.03036161, -0.01442995,
+                        -0.07624583, -0.06297061, -0.07733792,
+                        -0.06342237, -0.07695439, -0.06289595,
+                        -0.07635559, -0.0626065, -0.07633628,
+                        -0.06280072, -0.07739632, -0.06386738,
+                        -0.12161738, -0.11028239, -0.1223796,
+                        -0.11095953, -0.12189744, -0.11048616,
+                        -0.12074535, -0.10987605, -0.12014311,
+                        -0.10976691, -0.12096859, -0.11087692,
+                        -0.16868259, -0.15868061, -0.16801135,
+                        -0.1588003, -0.16674343, -0.15813323,
+                        -0.16457595, -0.15693826, -0.16281096,
+                        -0.15585154, -0.16283873, -0.15540068,
+                        -0.17450362, -0.19919913, -0.18062882,
+                        -0.19764131, -0.17783111, -0.19407213,
+                        -0.1736915, -0.19053624, -0.17228678,
+                        -0.19105634, -0.17920133, -0.1968828,
+                        -0.14244395, -0.14604641, -0.14473537,
+                        -0.1506107, -0.14510055, -0.14919522,
+                        -0.14175896, -0.14560798, -0.13911658,
+                        -0.14439383, -0.13924047, -0.14829043])
+                        
         
     def test_bedslope_problem_second_order_one_step(self):
@@ -1819,50 +1820,46 @@
             pass
 
+
+        #print domain.quantities['level'].centroid_values
+
+        
         assert allclose(domain.quantities['level'].centroid_values,
-                        [3.96042007e-002, 5.61081828e-002, 4.66578380e-002, 5.73165329e-002,
-                         4.72542001e-002, 5.74770060e-002, 4.74459150e-002, 5.77550805e-002,
-                         4.80791695e-002, 5.85754074e-002, 4.90681598e-002, 6.02682664e-002,
-                         1.16686827e-002, 1.75422685e-002, 1.17014731e-002, 2.15810992e-002,
-                         1.30549421e-002, 2.14416681e-002, 1.31212934e-002, 2.15486277e-002,
-                         1.34996488e-002, 2.24053139e-002, 1.50195194e-002, 2.22306851e-002,
-                         -7.26762170e-003, -1.35071582e-003, -7.88143638e-003,
-                         -2.18165245e-003, -7.81749271e-003, -1.06732807e-003,
-                         -7.76399231e-003, -1.00580353e-003, -7.81877765e-003,
-                         -9.81086203e-004, -7.42500800e-003, -2.41412070e-004, 1.86244453e-001,
-                         8.79324341e-002, 1.86232625e-001, 8.78313615e-002, 6.12537452e-002,
-                         -3.73125664e-002, -6.37550753e-002, -3.73269705e-002, 6.12145063e-002,
-                         8.77700677e-002, 1.86257693e-001, 8.79121535e-002, -4.83328632e-002,
-                         1.18336527e-001, -4.83328400e-002, 1.18337005e-001, -4.83328850e-002,
-                         -6.65776472e-003, -1.73331646e-001, -1.31654218e-001,
-                         -1.73332232e-001, -6.66097985e-003, -4.83323869e-002, 1.18339536e-001,
-                         -2.48333331e-001, -2.31666623e-001, -2.48333332e-001,
-                         -2.31666628e-001, -2.48333332e-001, -2.31666627e-001,
-                         -2.48333330e-001, -2.31666575e-001, -2.48333330e-001,
-                         -2.31666597e-001, -2.48333329e-001, -2.31666584e-001,
-                         -4.65000000e-001, -3.65000000e-001, -4.65000000e-001,
-                         -3.65000000e-001, -4.65000000e-001, -3.65000000e-001,
-                         -4.65000000e-001, -3.65000000e-001, -4.65000000e-001,
-                         -3.65000000e-001, -4.65000000e-001, -3.65000000e-001,
-                         -5.98333333e-001, -5.81666667e-001, -5.98333333e-001,
-                         -5.81666667e-001, -5.98333333e-001, -5.81666667e-001,
-                         -5.98333333e-001, -5.81666667e-001, -5.98333333e-001,
-                         -5.81666667e-001, -5.98333333e-001, -5.81666667e-001,
-                         -6.48333333e-001, -6.31666667e-001, -6.48333333e-001,
-                         -6.31666667e-001, -6.48333333e-001, -6.31666667e-001,
-                         -6.48333333e-001, -6.31666667e-001, -6.48333333e-001,
-                         -6.31666667e-001, -6.48333333e-001, -6.31666667e-001,
-                         -5.31666667e-001, -5.98333333e-001, -5.31666667e-001,
-                         -5.98333333e-001, -5.31666667e-001, -5.98333333e-001,
-                         -5.31666667e-001, -5.98333333e-001, -5.31666667e-001,
-                         -5.98333333e-001, -5.31666667e-001, -5.98333333e-001,
-                         -4.98333333e-001, -4.81666667e-001, -4.98333333e-001,
-                         -4.81666667e-001, -4.98333333e-001, -4.81666667e-001,
-                         -4.98333333e-001, -4.81666667e-001, -4.98333333e-001,
-                         -4.81666667e-001, -4.98333333e-001, -4.81666667e-001,
-                         -5.48333333e-001, -5.31666667e-001, -5.48333333e-001,
-                         -5.31666667e-001, -5.48333333e-001, -5.31666667e-001,
-                         -5.48333333e-001, -5.31666667e-001, -5.48333333e-001,
-                         -5.31666667e-001, -5.48333333e-001, -5.31666667e-001])
-        
+[3.95822638e-002,  5.61022588e-002,  4.66437868e-002,  5.73081011e-002,
+ 4.72394613e-002,  5.74684939e-002,  4.74309483e-002,  5.77458084e-002,
+ 4.80628177e-002,  5.85656225e-002,  4.90498542e-002,  6.02609831e-002,
+ 1.18470315e-002,  1.75136443e-002,  1.18035266e-002,  2.15565695e-002,
+ 1.31620268e-002,  2.14351640e-002,  1.32351076e-002,  2.15450687e-002,
+ 1.36414028e-002,  2.24274619e-002,  1.51689511e-002,  2.21789655e-002,
+-7.54337535e-003, -6.86362021e-004, -7.74146760e-003, -1.83756530e-003,
+-8.16773628e-003, -4.49916813e-004, -8.08202599e-003, -3.91118720e-004,
+-8.10292716e-003, -3.88584984e-004, -7.35226124e-003,  2.73985295e-004,
+ 1.86166683e-001,  8.74070369e-002,  1.86166712e-001,  8.74035875e-002,
+ 6.11666935e-002, -3.76173225e-002, -6.38333276e-002, -3.76147365e-002,
+ 6.11666725e-002,  8.73846774e-002,  1.86166697e-001,  8.74171550e-002,
+-4.83333333e-002,  1.18333333e-001, -4.83333333e-002,  1.18333333e-001,
+-4.83333333e-002, -6.66666667e-003, -1.73333333e-001, -1.31666667e-001,
+-1.73333333e-001, -6.66666667e-003, -4.83333333e-002,  1.18333333e-001,
+-2.48333333e-001, -2.31666667e-001, -2.48333333e-001, -2.31666667e-001,
+-2.48333333e-001, -2.31666667e-001, -2.48333333e-001, -2.31666667e-001,
+-2.48333333e-001, -2.31666667e-001, -2.48333333e-001, -2.31666667e-001,
+-4.65000000e-001, -3.65000000e-001, -4.65000000e-001, -3.65000000e-001,
+-4.65000000e-001, -3.65000000e-001, -4.65000000e-001, -3.65000000e-001,
+-4.65000000e-001, -3.65000000e-001, -4.65000000e-001, -3.65000000e-001,
+-5.98333333e-001, -5.81666667e-001, -5.98333333e-001, -5.81666667e-001,
+-5.98333333e-001, -5.81666667e-001, -5.98333333e-001, -5.81666667e-001,
+-5.98333333e-001, -5.81666667e-001, -5.98333333e-001, -5.81666667e-001,
+-6.48333333e-001, -6.31666667e-001, -6.48333333e-001, -6.31666667e-001,
+-6.48333333e-001, -6.31666667e-001, -6.48333333e-001, -6.31666667e-001,
+-6.48333333e-001, -6.31666667e-001, -6.48333333e-001, -6.31666667e-001,
+-5.31666667e-001, -5.98333333e-001, -5.31666667e-001, -5.98333333e-001,
+-5.31666667e-001, -5.98333333e-001, -5.31666667e-001, -5.98333333e-001,
+-5.31666667e-001, -5.98333333e-001, -5.31666667e-001, -5.98333333e-001,
+-4.98333333e-001, -4.81666667e-001, -4.98333333e-001, -4.81666667e-001,
+-4.98333333e-001, -4.81666667e-001, -4.98333333e-001, -4.81666667e-001,
+-4.98333333e-001, -4.81666667e-001, -4.98333333e-001, -4.81666667e-001,
+-5.48333333e-001, -5.31666667e-001, -5.48333333e-001, -5.31666667e-001,
+-5.48333333e-001, -5.31666667e-001, -5.48333333e-001, -5.31666667e-001,
+-5.48333333e-001, -5.31666667e-001, -5.48333333e-001, -5.31666667e-001])
+
 
         