Index: /inundation/ga/storm_surge/pyvolution/data_manager.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/data_manager.py	(revision 286)
+++ /inundation/ga/storm_surge/pyvolution/data_manager.py	(revision 287)
@@ -18,6 +18,4 @@
     s = s.strip()
     s = s.replace(' ', '_')
-    #s = s.replace('(', '{')
-    #s = s.replace(')', '}')
     s = s.replace('(', '')
     s = s.replace(')', '')
@@ -268,5 +266,5 @@
 
 
-#Function for storing out to e.g. visualisation
+#Generic class for storing output to e.g. visualisation or checkpointing
 class Data_format:
     """Generic interface to data formats
@@ -281,5 +279,4 @@
 
         #Create filename
-        #FIXME: This may change if separate timesteps are stored in separate files.
         self.filename = create_filename(domain.get_name(), extension, len(domain))
         self.timestep = 0
@@ -287,25 +284,24 @@
         self.domain = domain
     
-    
-
-    def store_connectivity(self):
-        """Writes x,y,z coordinates of triangles constituting
-        the bed elevation.
-        """
-
-        msg = 'Method should be overridden in concrete class'
-        raise msg
-
-    def store_timestep(self, t, V0, V1, V2):
-        """Store time, water heights (and momentums) to file
-        """
-
-        msg = 'Method should be overridden in concrete class'
-        raise msg        
+
+    # def store_connectivity(self):
+#         """Writes x,y,z coordinates of triangles constituting
+#         the bed elevation.
+#         """
+
+#         msg = 'Method should be overridden in concrete class'
+#         raise msg
+
+#     def store_timestep(self, t, V0, V1, V2):
+#         """Store time, water heights (and momentums) to file
+#         """
+
+#         msg = 'Method should be overridden in concrete class'
+#         raise msg        
     
     #FIXME: Should we have a general set_precision function?
     
 
-#Function for storing out to e.g. visualisation
+#Function for storing output to e.g. visualisation
 class Data_format_sww(Data_format):
     """Interface to native NetCDF format (.sww)
@@ -458,5 +454,7 @@
 
 
-#Function for storing out to e.g. visualisation
+
+
+#Function for storing xya output
 #FIXME Not done yet for this version
 class Data_format_xya(Data_format):
@@ -523,7 +521,4 @@
         #close
         fd.close()
-
-
-        
 
 
Index: /inundation/ga/storm_surge/pyvolution/netherlands.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/netherlands.py	(revision 286)
+++ /inundation/ga/storm_surge/pyvolution/netherlands.py	(revision 287)
@@ -91,5 +91,7 @@
 N = 264
 
-N = 600
+N = 600 #Size = 720000
+N = 100
+
 
 print 'Creating domain'
Index: /inundation/ga/storm_surge/pyvolution/shallow_water.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/shallow_water.py	(revision 286)
+++ /inundation/ga/storm_surge/pyvolution/shallow_water.py	(revision 287)
@@ -121,5 +121,5 @@
             #Store model data, e.g. for subsequent visualisation    
             if self.store is True:
-                self.writer.store_timestep('level')
+                self.store_timestep('level')
 		#FIXME: Could maybe be taken from specified list 
                 #of 'store every step' quantities       
@@ -131,5 +131,6 @@
 
     def initialise_storage(self):	
-        """Save x,y and bed elevation
+        """Create and initialise self.writer object for storing data.
+        Also, save x,y and bed elevation
 	"""
 
@@ -141,30 +142,13 @@
         #Store vertices and connectivity
         self.writer.store_connectivity()		    
+
+    def store_timestep(self, name):
+        """Store named quantity and time.
+
+        Precondition:
+           self.write has been initialised
+        """
+        self.writer.store_timestep(name)
 	
-    	
-
-    def store_quantity(self, name):
-        """Store named quantity to file using format and filename
-        """
-
-        #FIXME: NOT IN USE
-	
-        Q = self.quantities[name]
-        Q.store(self.filename, self.format)
-        
-        #FIXME: Use data_manager
-        #FIXME:
-        #  Initialisation
-        #  Storing of vertices (static)
-        #
-        #  Storing of elevation (typically static, but...)
-        #
-        #  Storing of level (dynamic)
-        #  Storing of time (dynamic)        
-        #
-        pass    
-
-    
-
 #Rotation of momentum vector
 def rotate(q, normal, direction = 1):
Index: /inundation/ga/storm_surge/pyvolution/show_balanced_limiters.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/show_balanced_limiters.py	(revision 286)
+++ /inundation/ga/storm_surge/pyvolution/show_balanced_limiters.py	(revision 287)
@@ -83,5 +83,5 @@
 for t in domain.evolve(yieldstep = 0.1, finaltime = 30):
     domain.write_time()
-    #print domain.quantities['level'].centroid_values[:6]
+
 print 'Done'    
     